	program latent

!	NOTE:  WINDS FROM 'radar_winds_all.dat' HAVE STORM MOTION REMOVED
	
	IMPLICIT NONE

	integer :: i,j,k,l,f

	real :: conv_u,conv_v,conv_w,conv_f,tend,ht,x,y,Cpd,Lc,LH1,LH2,hadvect,
     &qnetnew,conv_ut,conv_vt

	real,dimension(60,60,20,10) :: u,v,w,tfs,pwc,pwcl,pwcu,flux_u,flux_v,
     &flux_w,flux_f,qnetu,qnets,NLH1,NLH2,flux_ut,flux_vt

	real,dimension(20) :: qsz,T,theta
	real,dimension(10) :: umot,vmot

	open(1,file='storm_motion_all.dat')
	open(2,file='radar_winds_all.dat',form='binary')
	open(3,file='microphysics.dat',form='binary')
	open(7,file='qsz_t_theta_radar_grid_composite.drp')
!	open(5,file='nqsz_eyewall1.profile')
!	open(8,file='thermo_eyewall1.profile')
!	open(4,file='lh_composite_dropsondes.dat',form='binary',
!     &status='unknown')

!       open(4,file='lh_per_tend+0.004.dat',form='binary',status='unknown')
	open(4,file='water_budget_radar.dat',status='unknown')

	do l=1,10
	read(1,*)umot(l),vmot(l)
	enddo
	
	read(2)u,v,w
	read(3)tfs,pwc,pwcl,pwcu


!	DO f=1,6

	do i=1,20
!	read(5,*)ht
!	read(8,*)x,y
	read(7,*)ht,x,y
	qsz(i) = ht
	T(i) = x
	theta(i) = y
	enddo

        Cpd=1004.               !specific heat of dry air  J/K*kg
        Lc=2.50*10.**6.         !Latent Heat of Vaporization at 0 deg J/kg

!	Storm-relative fluxes
	flux_u = pwc*u
	flux_v = pwc*v
	flux_w = pwc*w
	flux_f = tfs*pwc

!	Total fluxes
	do l=1,10
	flux_ut(:,:,:,l) = pwc(:,:,:,l)*(u(:,:,:,l)+umot(l))
	flux_vt(:,:,:,l) = pwc(:,:,:,l)*(v(:,:,:,l)+vmot(l))
	enddo

	qnetu(1,:,:,:) = -9999.
	qnetu(60,:,:,:) = -9999.
	qnetu(:,1,:,:) = -9999.
	qnetu(:,60,:,:) = -9999.
	qnetu(:,:,1,:) = -9999.
	qnetu(:,:,20,:) = -9999.
	qnetu(:,:,:,1) = -9999.
	qnetu(:,:,:,10) = -9999.

        qnets(1,:,:,:) = -9999.
        qnets(60,:,:,:) = -9999.
        qnets(:,1,:,:) = -9999.
        qnets(:,60,:,:) = -9999.
        qnets(:,:,1,:) = -9999.
        qnets(:,:,20,:) = -9999.


	do l=1,10
	do k=2,19
	ht = k-1
	do j=2,59
	y = j*2 - 61
	do i=2,59
	x = i*2 - 61
	
	IF (pwc(i,j,k,l) .ne. -9999. .and. pwc(i+1,j,k,l) .ne. -9999. 
     &.and. pwc(i-1,j,k,l) .ne. -9999. .and. pwc(i,j+1,k,l) .ne. -9999. 
     &.and. pwc(i,j-1,k,l) .ne. -9999. .and. pwc(i,j,k+1,l) .ne. -9999. 
     &.and. pwc(i,j,k-1,l) .ne. -9999.) THEN

	conv_u = (flux_u(i+1,j,k,l) - flux_u(i-1,j,k,l))/(2.*2.*1000.)		!g/kg/s
	conv_u = conv_u/1000.							!kg/kg/s
	conv_v = (flux_v(i,j+1,k,l) - flux_v(i,j-1,k,l))/(2.*2.*1000.)		!g/kg/s
	conv_v = conv_v/1000.							!kg/kg/s
	conv_w = (flux_w(i,j,k+1,l) - flux_w(i,j,k-1,l))/(1.*2.*1000.)		!g/kg/s
	conv_w = conv_w/1000.							!kg/kg/s
	conv_f = (flux_f(i,j,k+1,l) - flux_f(i,j,k-1,l))/(1.*2.*1000.)		!g/kg/s
	conv_f = conv_f/1000.							!kg/kg/s
	
	conv_ut = (flux_ut(i+1,j,k,l) - flux_ut(i-1,j,k,l))/(2.*2.*1000.)  	!g/kg/s
	conv_ut = conv_ut/1000.							!kg/kg/s

	conv_vt = (flux_vt(i,j+1,k,l) - flux_vt(i,j-1,k,l))/(2.*2.*1000.) 	!g/kg/s
        conv_vt = conv_vt/1000.                                                 !kg/kg/s


	if (pwc(i,j,k,l) .ne. -9999. .and. pwc(i,j,k,l+1) .ne. -9999.) then
	tend = (pwc(i,j,k,l+1) - pwc(i,j,k,l))/(34.*1.*60.)			!g/kg/s
	tend = tend/1000.							!kg/kg/s
!	34 mintue time updates
	qnetu(i,j,k,l) = tend + conv_u + conv_v + conv_w - conv_f		!kg/kg/s	
	else
	qnetu(i,j,k,l) = -9999.
	tend = -9999.
	endif

!	MM5 water budget linear least squares regression estimate of tendency.  
!	Horizontal advection in model was TOTAL advection thus need TOTAL advection in obs

	hadvect = conv_ut + conv_vt						!kg/kg/s
	tend = 0.7943*hadvect + 2.431*10.**(-7.)				!kg/kg/s
	qnetnew = tend + conv_u + conv_v + conv_w - conv_f               	!kg/kg/s


!	Testing perturbations in divergence
!	conv_u = conv_u*1.30	!30% change
!	conv_v = conv_v*1.30	!30% change

!	Steady State
!	qnets(i,j,k,l) = 0 + conv_u + conv_v + conv_w - conv_f			!kg/kg/s	
!       qnets(i,j,k,l) = 0.004 + conv_u + conv_v + conv_w - conv_f      	!g/kg/s

	ELSE

	qnetu(i,j,k,l) = -9999.
	qnets(i,j,k,l) = -9999.
	qnetnew = -9999.

	conv_u = -9999.	
	conv_v = -9999.
	conv_w = -9999.
	conv_f = -9999.
	tend = -9999.

	ENDIF
	

	write(4,*)qnetu(i,j,k,l),qnets(i,j,k,l),qnetnew,conv_u,conv_v,conv_w,
     &conv_f,tend



	IF (T(k) .eq. -9999.) THEN	

	NLH1(i,j,k,l) = -9999.
	NLH2(i,j,k,l) = -9999.

	ELSE	
	
!       heating
        LH1 = (-1.*Lc*w(i,j,k,l)*qsz(k))/(Cpd*T(k))                	!s^-1

!       cooling
        LH2 = (Lc*qnets(i,j,k,l))/(Cpd*T(k))                     	!g/kg*s
	LH2 = LH2/1000.							!s^-1
	
        NLH1(i,j,k,l) = LH1*theta(k)*60.*60.                      	!K/h
	NLH2(i,j,k,l) = LH2*theta(k)*60.*60.				!K/h

	ENDIF

	if (qnets(i,j,k,l) .eq. -9999.) then
	NLH2(i,j,k,l) = -9999.
	endif

	enddo
	enddo
	enddo
	enddo

!	write(4)qnets,NLH1,NLH2
	
!	ENDDO

	end program latent
